/*******************************************************************
 * This file is part of the Emulex Linux Device Driver for         *
 * Fibre Channel Host Bus Adapters.                                *
 * Copyright (C) 2003-2006 Emulex.  All rights reserved.           *
 * EMULEX and SLI are trademarks of Emulex.                        *
 * www.emulex.com                                                  *
 *                                                                 *
 * This program is free software; you can redistribute it and/or   *
 * modify it under the terms of version 2 of the GNU General       *
 * Public License as published by the Free Software Foundation.    *
 * This program is distributed in the hope that it will be useful. *
 * ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND          *
 * WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY,  *
 * FITNESS FOR A PARTICULAR PURPOSE, OR NON-INFRINGEMENT, ARE      *
 * DISCLAIMED, EXCEPT TO THE EXTENT THAT SUCH DISCLAIMERS ARE HELD *
 * TO BE LEGALLY INVALID.  See the GNU General Public License for  *
 * more details, a copy of which can be found in the file COPYING  *
 * included with this package.                                     *
 *******************************************************************/

/*
 * $Id: mpl_ioctl.h 1005 2006-01-27 17:27:22Z hdaschbach $
 *
 * MPL Emulex driver ioctl support header file
 */

#ifndef _H_MPL_IOCTL
#define _H_MPL_IOCTL

#define _MPL_64BIT 1

#ifdef BITS_PER_LONG
#if BITS_PER_LONG < 64 
#undef _MPL_64BIT
#endif
#endif

#ifdef i386
#undef _MPL_64BIT
#endif

#ifdef powerpc
#ifndef CONFIG_PPC64
#undef _MPL_64BIT
#endif
#endif


#define ELX_MPL_INIT              	0x1 	/* Initialize the application */

#define ELX_MPL_PORTLIST       		0x2	/* Retrieves a list of port identifiers */
#define ELX_MPL_ROUTELIST       	0x3	/* Retrieves a list of  route identifiers */
#define ELX_MPL_PATHLIST        	0x4	/* Retrieves a list of path identifiers */
#define ELX_MPL_CREATE_ROUTE      	0x5	/* Create a new route specified by route id */
#define ELX_MPL_DELETE_ROUTE      	0x6	/* Delete a previuosly created route */
#define ELX_MPL_GET_PATH_CONTROL  	0x7	/* Retrieves path controls specified by route id */
#define ELX_MPL_SET_PATH_CONTROL  	0x8	/* Sets tha path controls specified by route id */
#define ELX_MPL_GET_PATH_STATUS 	0x9	/* Get status information about a specified path */
#define ELX_MPL_SET_PATH_STATUS		0xa	/* Set the path status speciied by path id */
#define ELX_MPL_GET_PATH_INFO     	0xb	/* Get specific information about a specific path */
#define ELX_MPL_ADD_PATH_LIST     	0xc	/* Add additional path to a predefined route */
#define ELX_MPL_REMOVE_PATH_LIST  	0xd	/* Remove specified paths from a list */
#define ELX_MPL_EXPORT_PATH_LIST        0xe     /* Exported paths from MPULSE */
#define ELX_MPL_IMPORT_PATH_LIST        0xf     /* Import paths to MPULSE */
#define ELX_MPL_GET_EXPORT_PATH_LIST    0x10    /* get a list of exported paths */
#define ELX_MPL_GETCFG                  0x11    /* get configuration */
#define ELX_MPL_SETCFG                  0x12    /* set configuration */


#define ELX_MPL_IOCTL			0x01	/* For IOCTL invocation */

/*
 * mpl ioctl Input structure
 */

typedef struct elxCmdInput {			/* For 64-bit copy_in */
#ifdef _MPL_64BIT			
   short                  elx_brd;
   short                  elx_ring;
   short                  elx_iocb;
   short                  elx_flag;
   void                  *elx_arg1;
   void                  *elx_arg2;
   void                  *elx_arg3;
   char                  *elx_dataout;
   uint32_t	          elx_cmd;
   uint32_t 	          elx_outsz; 
   uint32_t               elx_arg4;
   uint32_t               elx_arg5;
#else
   short                  elx_brd;
   short                  elx_ring;
   short                  elx_iocb;
   short                  elx_flag;
   void                  *elx_filler1;
   void                  *elx_arg1;
   void                  *elx_filler2;
   void                  *elx_arg2;
   void                  *elx_filler3;
   void                  *elx_arg3;
   void                  *elx_filler4;
   char                  *elx_dataout;
   uint32_t	          elx_cmd;
   uint32_t 	          elx_outsz; 
   uint32_t               elx_arg4;
   uint32_t               elx_arg5;
#endif /* _MPL_64BIT */    
} ELXCMDINPUT_t;

#endif /*  _H_MPL_IOCTL */

